#!/usr/bin/php
<?php
if (isset($_SERVER['REMOTE_ADDR'])) {
    die('Direct access not permitted');
}
// This script will output a 123solar counter into a meterN compatible format
// Configure, then ln -s /srv/http/comapps/pool123s.php /usr/bin/pool123s
// Request Main command with 'pool123s energy' and live command 'pool123s power'

// 123solar config
$pathto123s = '/srv/http/123solar';
$invtnum    = 1;
// meterN config
$pathtomn   = '/srv/http/metern';
$METERID    = 'solar';
$INVTmetnum = 4; // meter number

// No edit is needed below
if (isset($argv[1])) {
    define('checkaccess', TRUE);
    include("$pathto123s/config/config_main.php");
    include("$pathto123s/config/config_invt$invtnum.php");
    include("$pathto123s/config/memory.php");
    
    date_default_timezone_set($DTZ);
    
    $KWHT = null;
    if (file_exists($LIVEMEMORY)) {
			$data     = file_get_contents($LIVEMEMORY);
			$memarray = json_decode($data, true);
            $nowUTC = strtotime(date("Ymd H:i:s"));
            if ($argv[1] == 'power') {
                if ($nowUTC - $memarray["SDTE$invtnum"] < 30) {
                    $GP = $memarray["G1P$invtnum"] + $memarray["G2P$invtnum"] + $memarray["G3P$invtnum"];
                    if ($GP > 1000) {
                        $GP = round($GP, 0);
                    } else {
                        $GP = round($GP, 1);
                    }
                } else { // Too old
                    $GP = 0;
                }
            } elseif ($argv[1] == 'energy') {
                if ($nowUTC - $memarray["SDTE$invtnum"] < 30) {
                    $KWHT = $memarray["KWHT$invtnum"] * 1000; // Wh
                } else {
                    die("Abording: Too late value\n");
                }
            }
        
        
        if ($argv[1] == 'power') {
            echo "$METERID($GP*W)\n";
        } elseif ($argv[1] == 'energy') {
            if (empty($KWHT)) { // 123s ain't running at night retrieve the value in meterN csv
                $dir    = $pathtomn . '/data/csv/';
                $output = array();
                $output = glob($dir . '*.csv');
                sort($output);
                $cnt = count($output);
                
                if ($cnt > 0) {
                    $lines      = file($output[$cnt - 1]);
                    $contalines = count($lines);
                    
                    $KWHT = null;
                    $j    = 0;
                    while (empty($KWHT)) {
                        $j++;
                        $array = preg_split('/,/', $lines[$contalines - $j]);
                        $KWHT  = trim($array[$INVTmetnum]);
                        if ($j == $contalines) {
                            die("Abording: no value found in csv\n"); // No value found
                        }
                    }
                } else {
                    die("Abording: no csv\n");
                }
            }
            echo "$METERID($KWHT*Wh)\n";
        } else {
            die("Abording: no valid argument given\n");
        }
    } else { // 123s ain't running
        die("Abording: Empty SHM\n");
    }
} else {
    die("Usage: pool123solar { power | energy }\n");
}
?>
